use apt::AptTask;
use plugin_task::PluginTask;

use super::{plugins::PluginStore, task::IntoTask};

pub mod apt;
pub mod plugin_task;

pub struct Plan {
    store: PluginStore,
}
impl Plan {
    pub fn new(store: PluginStore) -> Self {
        Self { store }
    }

    pub async fn tasks(&self) -> anyhow::Result<Vec<impl IntoTask>> {
        Ok(vec![
            AptTask::new().into_task(),
            PluginTask::new("alloy@0.1.0", self.store.clone()).into_task(),
            PluginTask::new("dev_packages@0.1.0", self.store.clone()).into_task(),
        ])
    }
}
